package com.zswl.cloud.springBtach.server.core.api.xiaoju;

import com.google.gson.Gson;
import com.xiaoju.open.oil.commons.config.OilConfig;
import com.xiaoju.open.oil.core.QueryClient;
import com.xiaoju.open.oil.core.QueryClientFactory;
import com.xiaoju.open.oil.interfaces.domain.AllowanceInfo;
import com.xiaoju.open.oil.interfaces.domain.AllowancePromotionInfo;
import com.xiaoju.open.oil.interfaces.domain.CalBatchPriceItemInfo;
import com.xiaoju.open.oil.interfaces.domain.GenPromotionInfo;
import com.xiaoju.open.oil.interfaces.request.*;
import com.xiaoju.open.oil.interfaces.response.*;
import com.zswl.cloud.springBtach.server.core.dao.XiaoJuStoreDao;
import com.zswl.cloud.springBtach.server.core.domain.XiaoJuStore;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;


@Component
public class XiaoJuApi2 {



    @Autowired
    OilConfig oilConfig;

    @Autowired
    XiaoJuStoreDao xiaoJuStoreDao;

    // 查询门店详情
    public void queryStoreDetail() {

        QueryStoreDetailRequest queryStoreDetailRequest = new QueryStoreDetailRequest();

        queryStoreDetailRequest.setLat(28.4004F);
        queryStoreDetailRequest.setLon(112.7921F);
        queryStoreDetailRequest.setOutUserId("dajihao2");
        queryStoreDetailRequest.setStoreId("5154031457384536897");
        queryStoreDetailRequest.setOpenChannel(1);

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        QueryStoreDetailResponse queryStoreDetailResponse = queryClient.api().queryStoreDetail(queryStoreDetailRequest);

        System.out.println(new Gson().toJson(queryStoreDetailResponse));

    }

    // 查询门店价格
    public void queryStorePrice() {

        QueryApiStorePriceRequest queryApiStorePriceRequest = new QueryApiStorePriceRequest();
        queryApiStorePriceRequest.setOpenChannel(1);
        queryApiStorePriceRequest.setOutUserId("dajihao2");
        List<String> list = new ArrayList<>();
        list.add("5154031457384536897");
        queryApiStorePriceRequest.setStoreIds(list);


        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<QueryApiStorePriceResponse> list1 = queryClient.api().queryStorePrice(queryApiStorePriceRequest);

        System.out.println(new Gson().toJson(list1));

    }


    // 价格计算
    public void queryCalPrice() {
        QueryCalPriceRequest queryCalPriceRequest = new QueryCalPriceRequest();
        queryCalPriceRequest.setStoreId("5154031457384536897");
        queryCalPriceRequest.setOpenChannel(1);
        queryCalPriceRequest.setOutUserId("a09kWkRLM2ZWcWs9");
        queryCalPriceRequest.setItemName("92#");
        queryCalPriceRequest.setAmount(20000);

//        // 优惠券
//        List<AllowanceInfo> allowanceInfos = new ArrayList<>();
//        AllowanceInfo allowanceInfo = new AllowanceInfo();
//        allowanceInfo.setAllowanceId("E1-4ji-1kiJSL");
//        allowanceInfo.setAllowanceType(2);
//        allowanceInfos.add(allowanceInfo);
//
//        queryCalPriceRequest.setPromotionInfo(allowanceInfos);

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        QueryCalPriceResponse queryCalPriceResponse = queryClient.api().queryCalPrice(queryCalPriceRequest);

        System.out.println(new Gson().toJson(queryCalPriceResponse));

    }

    // 批量价格计算
    public void queryCalPrices() {
        QueryCalBatchPriceRequest queryCalPriceRequest = new QueryCalBatchPriceRequest();
        queryCalPriceRequest.setStoreId("5154031457384536897");
        queryCalPriceRequest.setOpenChannel(1);
        queryCalPriceRequest.setOutUserId("1640563200");

        // 优惠券
        List<CalBatchPriceItemInfo> itemList = new ArrayList<>();
        CalBatchPriceItemInfo calBatchPriceItemInfo = new CalBatchPriceItemInfo();
        calBatchPriceItemInfo.setItemName("92#");
        calBatchPriceItemInfo.setAmount(20000);
        itemList.add(calBatchPriceItemInfo);

        queryCalPriceRequest.setItemList(itemList);


        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        QueryCalBatchPriceResponse queryCalBatchPriceResponse = queryClient.api().queryCalPrices(queryCalPriceRequest);

        System.out.println(new Gson().toJson(queryCalBatchPriceResponse));

    }

    // 创建订单
    public void queryNewOrder() {
        QueryNewOrderRequest queryNewOrderRequest = new QueryNewOrderRequest();
        queryNewOrderRequest.setOutUserId("a09kWkRLM2ZWcWs9");
        queryNewOrderRequest.setMobile("13111222233");
        queryNewOrderRequest.setOutOrderId("123456789");
        queryNewOrderRequest.setLat(114.30F);
        queryNewOrderRequest.setLon(14.23F);
        queryNewOrderRequest.setStoreId("5211967762877389105");
        queryNewOrderRequest.setItemId(4879454965524071453L);
        queryNewOrderRequest.setGunNo("10");
        queryNewOrderRequest.setOriginalAmount(20000);
        queryNewOrderRequest.setPaymentAmount(18000);
        queryNewOrderRequest.setServiceFee(20);
        queryNewOrderRequest.setLitre(382);
        queryNewOrderRequest.setVipPrice(460);
        queryNewOrderRequest.setStorePrice(523);

        // 优惠券
        List<AllowanceInfo> allowanceInfos = new ArrayList<>();
        AllowanceInfo allowanceInfo = new AllowanceInfo();
        allowanceInfo.setAllowanceId("E1-4ji-1kiJSL");
        allowanceInfo.setAllowanceType(2);
        allowanceInfos.add(allowanceInfo);

        queryNewOrderRequest.setPromotionInfo(allowanceInfos);

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        QueryNewOrderResponse queryNewOrderResponse = queryClient.api().queryNewOrder(queryNewOrderRequest);

        System.out.println(new Gson().toJson(queryNewOrderResponse));

    }

    // 同步订单状态
    public void syncOrderStatus() {
        SynOrderStatusRequest synOrderStatusRequest = new SynOrderStatusRequest();
        synOrderStatusRequest.setOutOrderId("123456789");
        synOrderStatusRequest.setXjOrderId("3476780108933473940");
        synOrderStatusRequest.setOrderStatus(9);

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        queryClient.api().syncOrderStatus(synOrderStatusRequest);

    }

    // 退款状态同步
    public void SyncRefundStatus() {
        SynRefundStatusRequest synRefundStatusRequest = new SynRefundStatusRequest();
        synRefundStatusRequest.setOutOrderId("123456789");
        synRefundStatusRequest.setXjOrderId("35489273812090023831");
        synRefundStatusRequest.setRefundStatus(1);
        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        queryClient.api().syncRefundStatus(synRefundStatusRequest);
    }


    // 下单前查询最优可用券
    public void queryOrderPromotionList() {
        QueryOrderPromotionListRequest request = new QueryOrderPromotionListRequest();
        request.setMobile("15210240132");
        request.setOutUserId("80200281708");
        request.setStoreId("5429504232738269218");
        request.setAllowanceType(2);
        request.setOrderAmount(24500);
        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<AllowancePromotionInfo> response = queryClient.promotion().queryOrderPromotionList(request);

        System.out.println(response);
    }

    // 查询多个门店可用券
    public void queryStorePromotionList() {
        QueryStorePromotionListRequest request = new QueryStorePromotionListRequest();
        request.setMobile("152102401323");
        request.setAllowanceType(2);
        request.setOutUserId("1223131");
        List<String> storeIdList = new ArrayList<String>();
        storeIdList.add("5429504232738269218");
        request.setStoreIdList(storeIdList);
        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<AllowancePromotionInfo> response = queryClient.promotion().queryStorePromotionList(request);

        System.out.println();
    }

    // 查询用户所有券列表
    public void queryUserPromotionList() {
        QueryUserPromotionListRequest request = new QueryUserPromotionListRequest();
        request.setAllowanceType(2);
        request.setOrderAmount(2400);

        request.setMobile("13758284401");
        request.setOutUserId("dajihao");


        request.setStatus(-2);
        request.setPageIndex(1);
        request.setPageSize(20);
        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        QueryUserPromotionListResponse response = queryClient.promotion().queryUserPromotionList(request);

        System.out.println(response);

    }

    // 获取优惠券
    public void getPromotion() {
        QueryGetPromotionRequest request = new QueryGetPromotionRequest();
        request.setOutUserId("18874");
        request.setActivityId("983425694278877184");
        request.setTradeNo("2202071307003069990");
        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<GenPromotionInfo> response = queryClient.promotion().getPromotion(request);

        System.out.println();
    }


}
